/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Quickfile extension for Thunderbird.
 *
 * The Initial Developer of the Original Code is Paul Tomlin.
 * Portions created by the Initial Developer are Copyright (C) 2005, 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Paul Tomlin
 *  Mark Shuttleworth
 *
 * ***** END LICENSE BLOCK ***** */

/* $Id$ */

var gQuickfileThreadController =
{
  supportsCommand: function _supportsCommand (command)
  {
//dump("supportsCommand(" + command + ")\n");
    switch (command) {
      case 'cmd_quickfile_copy':
      case 'cmd_quickfile_instamove':
      case 'cmd_quickfile_instacopy':
      case 'cmd_quickfile_move':
        return true;
      default:
        return false;
    }
  },

  isCommandEnabled: function _isCommandEnabled (command)
  {
//dump("isCommandEnabled(" + command + ")\n");
    switch (command) {
      case 'cmd_quickfile_copy':
      case 'cmd_quickfile_instamove':
      case 'cmd_quickfile_instacopy':
      case 'cmd_quickfile_move':
        var threadTree = document.getElementById('threadTree');
        return (threadTree && threadTree.view && threadTree.view.selection && threadTree.view.selection.getRangeCount());
      default:
        return false;
    }
  },

  doCommand: function _doCommand (command)
  {
//dump("doCommand(" + command + ")\n");
    switch (command) {
      case 'cmd_quickfile_copy':
        return goQuickfileCopy();
      case 'cmd_quickfile_instamove':
        return goQuickfileInstaMove();
      case 'cmd_quickfile_instacopy':
        return goQuickfileInstaCopy();
      case 'cmd_quickfile_move':
        return goQuickfileMove();
      default:
        return false;
    }
  },

  onEvent: function _onEvent (evt)
  {
  }
};

function goUpdateQuickfileCommands() {
//  dump("goUpdateQuickfileCommands()\n");

//var controller = document.commandDispatcher.getControllerForCommand("cmd_quickfile_copy");
//dump("  controller: " + controller + "\n");

  goUpdateCommand('cmd_quickfile_copy');
  goUpdateCommand('cmd_quickfile_move');
  goUpdateCommand('cmd_quickfile_instacopy');
  goUpdateCommand('cmd_quickfile_instacopy');
}

function onLoadQuickfileMessengerOverlay() {
//  dump("onLoadQuickfileMessengerOverlay()\n");

  if (document.getElementById('threadTree'))
    document.getElementById('threadTree').controllers.appendController(gQuickfileThreadController);
}

function onUnloadQuickfileMessengerOverlay() {
//  dump("onUnloadQuickfileMessengerOverlay()\n");

  if (document.getElementById('threadTree'))
    document.getElementById('threadTree').controllers.removeController(gQuickfileThreadController);
}

window.addEventListener('load', function () { onLoadQuickfileMessengerOverlay(); }, false);
window.addEventListener('unload', function () { onUnloadQuickfileMessengerOverlay(); }, false);
